if not BLTRCD then return end
local BLTRCD = BLTRCD
 
BLTRCD.classes = {
    "DEATHKNIGHT",
    "DRUID",
    "HUNTER",
    "MAGE",
    "MONK",
    "PALADIN",
    "PRIEST",
    "ROGUE",
    "SHAMAN",
    "WARLOCK",
    "WARRIOR",
    "ALL",
}
 
BLTRCD.cooldowns = {
    -- debug mode
    { -- Ice floes
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 108839,
        name = "BLT_DEBUG",
        real_name = "Ice Floes",
        succ = "SPELL_CAST_SUCCESS",
        CD = 20,
        class = "MAGE",
        category = "AOE_HEAL",
        duration = 15,
        charges = 3,
    },
    -- Paladin
    { -- Devotion Aura
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 31821,
        name = "PAL_DA",
        real_name = "Devotion Aura",
        succ = "SPELL_CAST_SUCCESS",
        CD = 180,
        class = "PALADIN",
        category = "AOE_HEAL",
        duration = 6,
        spec_list = { [65] = true },
    },
    { -- Hand of Sacrifice
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 6940,
        name = "PAL_HOS",
        real_name = "Hand of Sacrifice",
        succ = "SPELL_CAST_SUCCESS",
        CD = 120,
        class = "PALADIN",
        category = "SINGLE_HEAL",
        duration = 0,
    },
    { -- Lay on Hands
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 633,
        name = "PAL_LOH",
        real_name = "Lay on Hands",
        succ = "SPELL_CAST_SUCCESS",
        CD = 600,
        class = "PALADIN",
        category = "SINGLE_HEAL",
        duration = 0,
    },
    { -- Hand of Purity
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 114039,
        name = "PAL_HOPUR",
        real_name = "Hand of Purity",
        succ = "SPELL_CAST_SUCCESS",
        CD = 30,
        class = "PALADIN",
        category = "SINGLE_HEAL",
        duration = 6,
    },
    { -- Hand of Protection
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 1022,
        name = "PAL_HOPRO",
        real_name = "Hand of Protection",
        succ = "SPELL_CAST_SUCCESS",
        CD = 300,
        class = "PALADIN",
        category = "UTILITY",
        duration = 10,
    },
    { -- Divine Shield
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 642,
        name = "PAL_DSHIELD",
        real_name = "Divine Shield",
        succ = "SPELL_CAST_SUCCESS",
        CD = 300,
        class = "PALADIN",
        category = "DEFENSIVE",
        duration = 8,
    },
    { -- Divine Protection
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 498,
        name = "PAL_DPROT",
        real_name = "Divine Protection",
        succ = "SPELL_CAST_SUCCESS",
        CD = 60,
        class = "PALADIN",
        category = "DEFENSIVE",
        duration = 8,
    },
 
    -- Priest
    { -- Leap of Faith
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 73325,
        succ = "SPELL_CAST_SUCCESS",
        name = "PRI_LOFAITH",
        real_name = "Leap of Faith",
        CD = 90,
        class = "PRIEST",
        category = "UTILITY",
        duration = 0,
    },    
    { -- Power Word: Barrier
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 62618,
        succ = "SPELL_CAST_SUCCESS",
        name = "PRI_PWB",
        real_name = "Power Word: Barrier",
        CD = 180,
        class = "PRIEST",
        category = "AOE_HEAL",
        duration = 10,
        spec_list = { [256] = true },
    },
    { -- Pain Suppression  
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 33206,
        succ = "SPELL_CAST_SUCCESS",
        name = "PRI_PS",
        real_name = "Pain Suppression",
        CD = 180,
        class = "PRIEST",
        category = "SINGLE_HEAL",
        duration = 8,
        spec_list = { [256] = true },
    },
    { -- Divine Hymn
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 64843,
        succ = "SPELL_CAST_SUCCESS",
        name = "PRI_DH",
        real_name = "Divine Hymn",
        CD = 180,
        class = "PRIEST",
        category = "AOE_HEAL",
        duration = 8,
        spec_list = { [257] = true },
    },    
    { -- Guardian Spirit
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 47788,
        succ = "SPELL_CAST_SUCCESS",
        name = "PRI_GS",
        real_name = "Guardian Spirit",
        CD = 180,
        class = "PRIEST",
        category = "SINGLE_HEAL",
        duration = 10,
        spec_list = { [257] = true },
    },    
    { -- Divine Star
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 110744,
        succ = "SPELL_CAST_SUCCESS",
        name = "PRI_DS",
        real_name = "Divine Star",
        CD = 15,
        class = "PRIEST",
        category = "AOE_HEAL",
        duration = 0,
        spec_list = { [256] = true, [257] = true },
        talent = 19760,
    },
    { -- Vampiric Embrace
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 15286,
        succ = "SPELL_CAST_SUCCESS",
        name = "PRI_VE",
        real_name = "Vampiric Embrace",
        CD = 180,
        class = "PRIEST",
        category = "AOE_HEAL",
        duration = 15,
        spec_list = { [258] = true },
    },    
    { -- Lightwell
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 724,
        succ = "SPELL_CAST_SUCCESS",
        name = "PRI_LWELL",
        real_name = "Lightwell",
        CD = 180,
        class = "PRIEST",
        category = "SINGLE_HEAL",
        duration = 0,
        spec_list = { [257] = true },
    },
    { -- Spirit Shell
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 109964,
        succ = "SPELL_CAST_SUCCESS",
        name = "PRI_SSHELL",
        real_name = "Spirit Shell",
        CD = 60,
        class = "PRIEST",
        category = "AOE_HEAL",
        duration = 15,
        spec_list = { [256] = true },
    },
    { -- Desperate Prayer
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 19236,
        succ = "SPELL_CAST_SUCCESS",
        name = "PRI_DPRAY",
        real_name = "Desperate Prayer",
        CD = 120,
        class = "PRIEST",
        category = "DEFENSIVE",
        duration = 0,
        talent = 19752,
    }, 
    { -- Dispersion
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 47585,
        succ = "SPELL_CAST_SUCCESS",
        name = "PRI_DISP",
        real_name = "Desperate Prayer",
        CD = 120,
        class = "PRIEST",
        category = "DEFENSIVE",
        duration = 6,
        spec_list = { [258] = true },
        glyphReduceCD = { 63229, 15 },
    },    
               
    -- Druid
    { -- Nature's Vigil
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 124974,
        succ = "SPELL_CAST_SUCCESS",
        name = "DRU_NG",
        real_name = "Nature's Vigil",
        CD = 90,
        class = "DRUID",
        category = "AOE_HEAL",
        duration = 30,
        talent = 18586,
    },        
    { -- Tranquility
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 740,
        succ = "SPELL_CAST_SUCCESS",
        name = "DRU_TRANQ",
        real_name = "Tranquility",
        CD = 180,
        class = "DRUID",
        spec_list = { [105] = true },
        category = "AOE_HEAL",
        duration = 8,
    },
    { -- Ironbark
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 102342,
        succ = "SPELL_CAST_SUCCESS",
        name = "DRU_FE",
        real_name = "Ironbark",
        CD = 60,
        class = "DRUID",
        spec_list = { [105] = true },
        category = "SINGLE_HEAL",
        duration = 12,
    },
    { -- Rebirth
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 20484,
        succ = "SPELL_RESURRECT",
        name = "DRU_REZ",
        real_name = "Rebirth",
        CD = 600,
        class = "DRUID",
        category = "REZ",
        duration = 0,
    },
    { -- Barkskin
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 22812,
        succ = "SPELL_CAST_SUCCESS",
        name = "DRU_BAR",
        real_name = "Barkskin",
        CD = 60,
        class = "DRUID",
        category = "DEFENSIVE",
        duration = 12,
        spec_list = { [102] = true, [104] = true, [105] = true }
    },
    { -- Renewal
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 108238,
        succ = "SPELL_CAST_SUCCESS",
        name = "DRU_RENEW",
        real_name = "Renewal",
        CD = 120,
        class = "DRUID",
        category = "DEFENSIVE",
        duration = 0,
        talent = 19283,
    },
    { -- Survival Instincts
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 61336,
        succ = "SPELL_CAST_SUCCESS",
        name = "DRU_SI",
        real_name = "Survival Instincts",
        CD = 180,
        class = "DRUID",
        category = "DEFENSIVE",
        duration = 6,
        spec_list = { [103] = true, [104] = true },
        glyphReduceCD = { 114223, 40 },
    },
    { -- Stampeding Roar
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 106898,
        altSpellID = { [77764] = "cat_feral" },
        succ = "SPELL_CAST_SUCCESS",
        name = "DRU_SROAR",
        real_name = "Stampeding Roar",
        CD = 120,
        class = "DRUID",
        category = "UTILITY",
        duration = 8,
    },
    -- Shaman
    { -- Capacitor Totem
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 108269,
        succ = "SPELL_CAST_SUCCESS",
        name = "SHA_CTOTEM",
        real_name = "Capacitor Totem",
        CD = 45,
        class = "SHAMAN",
        category = "AOE_STUN",
        duration = 5,
    },    
    { -- Ancestral Guidance
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 114911,
        succ = "SPELL_CAST_SUCCESS",
        name = "SHA_AG",
        real_name = "Ancestral Guidance",
        CD = 120,
        class = "SHAMAN",
        category = "AOE_HEAL",
        duration = 10,
        talent = 19269,
    },
    { -- Spirit Link Totem
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 98008,
        succ = "SPELL_CAST_SUCCESS",
        name = "SHA_SLT",
        real_name = "Spirit Link Totem",
        CD = 180,
        class = "SHAMAN",
        category = "AOE_HEAL",
        duration = 6,
        spec_list = { [264] = true },
    },
    { -- Ascendance
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 114049,
        succ = "SPELL_CAST_SUCCESS",
        name = "SHA_ASC_2",
        real_name = "Ascendance",
        CD = 180,
        class = "SHAMAN",
        category = "AOE_HEAL",
        duration = 15,
        spec_list = { [264] = true },
    },
    { -- Healing Tide Totem
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 108280,
        succ = "SPELL_CAST_SUCCESS",
        name = "SHA_HTT",
        real_name = "Healing Tide Totem",
        CD = 180,
        class = "SHAMAN",
        category = "AOE_HEAL",
        duration = 10,
        spec_list = { [264] = true },
    },
    { -- Fire Elemental Totem
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 2894,
        succ = "SPELL_CAST_SUCCESS",
        name = "SHA_FET",
        real_name = "Fire Elemental Totem",
        CD = 300,
        class = "SHAMAN",
        category = "UTILITY",
        duration = 60,
        glyphReduceCD = { 55455, 120 },
    },
    { -- Reincarnation
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 20608,
        succ = "SPELL_RESURRECT",
        name = "SHA_RE",
        real_name = "Reincarnation",
        CD = 1800,
        class = "SHAMAN",
        category = "REZ",
        duration = 0,
    },
    { -- Astral Shift
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 108271,
        succ = "SPELL_CAST_SUCCESS",
        name = "SHA_ASHIFT",
        real_name = "Astral Shift",
        CD = 90,
        class = "SHAMAN",
        category = "DEFENSIVE",
        duration = 6,
        talent = 19264,
    },
    { -- Stone Bulwark Totem
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 108270,
        succ = "SPELL_CAST_SUCCESS",
        name = "SHA_SBTOT",
        real_name = "Stone Bulwark Totem",
        CD = 60,
        class = "SHAMAN",
        category = "DEFENSIVE",
        duration = 30,
        talent = 19263,
    },
    { -- Shamanistic Rage
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 30823,
        succ = "SPELL_CAST_SUCCESS",
        name = "SHA_SRAGE",
        real_name = "Shamanistic Rage",
        CD = 60,
        class = "SHAMAN",
        category = "DEFENSIVE",
        duration = 15,
        spec_list = { [262] = true, [263] = true },
    },
         
    -- Monk
    {   -- Leg Sweep
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 119381,
        succ = "SPELL_CAST_SUCCESS",
        name = "MON_LSWEEP",
        real_name = "Leg Sweep",
        CD = 45,
        class = "MONK",
        category = "AOE_STUN",
        duration = 5,
        talent = 19995,
    },    
    {   -- Zen Meditation
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 115176,
        succ = "SPELL_CAST_SUCCESS",
        name = "MON_ZEN",
        real_name = "Zen Meditation",
        CD = 180,
        class = "MONK",
        category = "SINGLE_HEAL",
        duration = 8,
        spec_list = { [268] = true, [269] = true }
    },
    {   -- Life Cocoon
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 116849,
        succ = "SPELL_CAST_SUCCESS",
        name = "MON_LIFE",
        real_name = "Life Cocoon",
        CD = 120,
        class = "MONK",
        category = "SINGLE_HEAL",
        duration = 12,
        spec_list = { [270] = true },
    },
    {  -- Revival
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 115310,
        succ = "SPELL_CAST_SUCCESS",
        name = "MON_REV",
        real_name = "Revival",
        CD = 180,
        class = "MONK",
        category = "AOE_HEAL",
        duration = 0,
        spec_list = { [270] = true },
    },
    {  -- Chi Burst
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 123986,
        succ = "SPELL_CAST_SUCCESS",
        name = "MON_CB",
        real_name = "Chi Burst",
        CD = 30,
        class = "MONK",
        category = "AOE_HEAL",
        duration = 0,
        talent = 19823,
    },
    {   -- Fortifying Brew
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 115203,
        succ = "SPELL_CAST_SUCCESS",
        name = "MON_FBREW",
        real_name = "Fortifying Brew",
        CD = 180,
        class = "MONK",
        category = "DEFENSIVE",
        duration = 15,
    },
    {   -- Dampen Harm
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 122278,
        succ = "SPELL_CAST_SUCCESS",
        name = "MON_DHARM",
        real_name = "Dampen Harm",
        CD = 90,
        class = "MONK",
        category = "DEFENSIVE",
        duration = 0,
        talent = 20175,
    },
    {   -- Diffuse Magic
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 122783,
        succ = "SPELL_CAST_SUCCESS",
        name = "MON_DMAG",
        real_name = "Diffuse Magic",
        CD = 90,
        class = "MONK",
        category = "DEFENSIVE",
        duration = 6,
        talent = 20173,
    },
    {   -- Touch of Karma
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 122470,
        succ = "SPELL_CAST_SUCCESS",
        name = "MON_TOKAR",
        real_name = "Touch of Karma",
        CD = 90,
        class = "MONK",
        category = "DEFENSIVE",
        duration = 10,
        spec_list = { [269] = true },
    },    
    -- Warlock
    {   -- Demonic Gateway
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 111771,
        succ = "SPELL_CAST_SUCCESS",
        name = "LOC_DGATEWAY",
        real_name = "Demonic Gateway",
        CD = 10,
        class = "WARLOCK",
        category = "UTILITY",
        duration = 0,
    },    
    {   -- Shadowfury
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 30283,
        succ = "SPELL_CAST_SUCCESS",
        name = "LOC_SF",
        real_name = "Shadowfury",
        CD = 30,
        class = "WARLOCK",
        category = "AOE_STUN",
        duration = 3,
        talent = 19286,
    },    
    {   -- Soulstone Resurrection
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 20707,
        succ = "SPELL_RESURRECT",
        name = "LOC_SR",
        real_name = "Soulstone Resurrection",
        CD = 900,
        class = "WARLOCK",
        category = "REZ",
        duration = 0,
    },
    {    -- Unending Resolve
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 104773,
        succ = "SPELL_CAST_SUCCESS",
        name = "LOC_URESOLVE",
        real_name = "Unending Resolve",
        CD = 180,
        class = "WARLOCK",
        category = "DEFENSIVE",
        duration = 8,
    },
    {   -- Dark Regeneration
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 108359,
        succ = "SPELL_CAST_SUCCESS",
        name = "LOC_DREGEN",
        real_name = "Dark Regeneration",
        CD = 120,
        class = "WARLOCK",
        category = "DEFENSIVE",
        duration = 12,
        talent = 19279,
    },
    {   -- Dark Bargain
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 110913,
        succ = "SPELL_CAST_SUCCESS",
        name = "LOC_DBARGAIN",
        real_name = "Dark Bargain",
        CD = 180,
        class = "WARLOCK",
        category = "DEFENSIVE",
        duration = 8,
        talent = 19289,
    },
    {   -- Sacrificial Pact
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 108416,
        succ = "SPELL_CAST_SUCCESS",
        name = "LOC_SPACT",
        real_name = "Sacrificial Pact",
        CD = 60,
        class = "WARLOCK",
        category = "DEFENSIVE",
        duration = 20,
        talent = 19288,
    },    
    -- Death Knight
    {   -- Raise Ally
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 61999,
        succ = "SPELL_RESURRECT",
        name = "DEA_RA",
        real_name = "Raise Ally",
        CD = 600,
        class = "DEATHKNIGHT",
        category = "REZ",
        duration = 0,
    },
    {   -- Anti-Magic Zone
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 51052,
        succ = "SPELL_CAST_SUCCESS",
        name = "DEA_AMZ",
        real_name = "Anti-Magic Zone",
        CD = 120,
        class = "DEATHKNIGHT",
        category = "AOE_HEAL",
        duration = 3,
        talent = 19219,
    },
    {   -- Remorseless Winter
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 108200,
        succ = "SPELL_CAST_SUCCESS",
        name = "DEA_RW",
        real_name = "Remorseless Winter",
        CD = 60,
        class = "DEATHKNIGHT",
        category = "AOE_STUN",
        duration = 8,
        talent = 19231,
    },    
    {   -- Gorefiend's Grasp
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 108199,
        succ = "SPELL_CAST_SUCCESS",
        name = "DEA_GG",
        real_name = "Gorefiends's Grasp",
        CD = 60,
        class = "DEATHKNIGHT",
        category = "UTILITY",
        duration = 0,
        talent = 19230,
    },
    {   -- Icebound Fortitude
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 48792,
        succ = "SPELL_CAST_SUCCESS",
        name = "DEA_IBF",
        real_name = "Icebound Fortitude",
        CD = 180,
        class = "DEATHKNIGHT",
        category = "DEFENSIVE",
        duration = 8,
        glyphReduceCD = { 58673, 90 },
    },
    {   -- Army of the Dead
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 42650,
        succ = "SPELL_CAST_SUCCESS",
        name = "DEA_AOTD",
        real_name = "Army of the Dead",
        CD = 600,
        class = "DEATHKNIGHT",
        category = "DEFENSIVE",
        duration = 40,
    },
    {   -- Anti-Magic Shell
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 48707,
        succ = "SPELL_CAST_SUCCESS",
        name = "DEA_AMS",
        real_name = "Anti-Magic Shell",
        CD = 45,
        class = "DEATHKNIGHT",
        category = "DEFENSIVE",
        duration = 5,
    },
    {   -- Death Pact
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 48743,
        succ = "SPELL_CAST_SUCCESS",
        name = "DEA_DP",
        real_name = "Death Pact",
        CD = 120,
        class = "DEATHKNIGHT",
        category = "DEFENSIVE",
        duration = 0,
        talent = 19226,
    },
    {   -- Bone Shield
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 49222,
        succ = "SPELL_CAST_SUCCESS",
        name = "DEA_BS",
        real_name = "Bone Shield",
        CD = 60,
        class = "DEATHKNIGHT",
        category = "DEFENSIVE",
        duration = 8,
        spec_list = { [250] = true },
    },
    {   -- Dancing rune
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 49028,
        succ = "SPELL_CAST_SUCCESS",
        name = "DEA_BS",
        real_name = "Dancing rune",
        CD = 90,
        class = "DEATHKNIGHT",
        category = "DEFENSIVE",
        duration = 8,
        spec_list = { [250] = true },
    },
    {   -- Rune Tap
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 48982,
        succ = "SPELL_CAST_SUCCESS",
        name = "DEA_RT",
        real_name = "Rune Tap",
        CD = 40,
        class = "DEATHKNIGHT",
        category = "DEFENSIVE",
        duration = 3,
        spec_list = { [250] = true },
    },
    {   -- Vampiric Blood
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 55233,
        succ = "SPELL_CAST_SUCCESS",
        name = "DEA_VB",
        real_name = "Vampiric Blood",
        CD = 60,
        class = "DEATHKNIGHT",
        category = "DEFENSIVE",
        duration = 10,
        spec_list = { [250] = true },
    },
    -- Warrior
    {   -- Shockwave
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 46968,
        succ = "SPELL_CAST_SUCCESS",
        name = "WAR_SWAVE",
        real_name = "Shockwave",
        CD = 20,
        class = "WARRIOR",
        category = "AOE_STUN",
        duration = 4,
        talent = 15760,
    },    
    {   -- Rallying Cry
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 97462,
        succ = "SPELL_CAST_SUCCESS",
        name = "WAR_RCRY",
        real_name = "Rallying Cry",
        CD = 180,
        class = "WARRIOR",
        category = "AOE_HEAL",
        duration = 10,
        spec_list = { [71] = true, [72] = true },
    },
    {   -- Vigilance
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 114030,
        succ = "SPELL_CAST_SUCCESS",
        name = "WAR_VIGI",
        real_name = "Vigilance",
        CD = 120,
        class = "WARRIOR",
        category = "SINGLE_HEAL",
        duration = 12,
        talent = 19676,
    },
    {   -- Safeguard
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 114029,
        succ = "SPELL_CAST_SUCCESS",
        name = "WAR_SGUARD",
        real_name = "Safeguard",
        CD = 30,
        class = "WARRIOR",
        category = "SINGLE_HEAL",
        duration = 6,
        talent = 15766,
    },
    {   -- Demoralizing Shout
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 1160,
        succ = "SPELL_CAST_SUCCESS",
        name = "WAR_DSHOUT",
        real_name = "Demoralizing Shout",
        CD = 60,
        class = "WARRIOR",
        category = "DEFENSIVE",
        duration = 8,
        spec_list = { [73] = true },
    },
    {   -- Shield Wall
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 871,
        succ = "SPELL_CAST_SUCCESS",
        name = "WAR_SWALL",
        real_name = "Shield Wall",
        CD = 180,
        class = "WARRIOR",
        category = "DEFENSIVE",
        duration = 8,
        spec_list = { [73] = true },
        glyphReduceCD = { 63329, -120 },
    },
    {   -- Die by the sword
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 118038,
        succ = "SPELL_CAST_SUCCESS",
        name = "WAR_DBTW",
        real_name = "Die by the Sword",
        CD = 120,
        class = "WARRIOR",
        category = "DEFENSIVE",
        duration = 8,
        spec_list = { [71] = true, [72] = true },
    },
    {   -- Last Stand
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 12975,
        succ = "SPELL_CAST_SUCCESS",
        name = "WAR_LSTAND",
        real_name = "Last Stand",
        CD = 180,
        class = "WARRIOR",
        category = "DEFENSIVE",
        duration = 15,
        spec_list = { [73] = true },
    },
    {   -- Enraged Regeneration
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 55694,
        succ = "SPELL_CAST_SUCCESS",
        name = "WAR_EREGEN",
        real_name = "Enraged Regeneration",
        CD = 60,
        class = "WARRIOR",
        category = "DEFENSIVE",
        duration = 5,
        talent = 16036,
    },
    -- Rogue
    {   -- Smoke Bomb
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 76577,
        succ = "SPELL_CAST_SUCCESS",
        name = "ROG_SB",
        real_name = "Smoke Bomb",
        CD = 180,
        class = "ROGUE",
        category = "AOE_HEAL",
        duration = 5,
    },
    {   -- Feint
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 1966,
        succ = "SPELL_CAST_SUCCESS",
        name = "ROG_FEINT",
        real_name = "Feint",
        CD = 5,
        class = "ROGUE",
        category = "DEFENSIVE",
        duration = 5,
    },
    -- Mage
    {   -- Amplify Magic
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 159916,
        succ = "SPELL_CAST_SUCCESS",
        name = "MAG_AM",
        real_name = "Amplify Magic",
        CD = 120,
        class = "MAGE",
        category = "AOE_HEAL",
        duration = 6,
    },    
    {   -- Ice Block
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 45438,
        succ = "SPELL_CAST_SUCCESS",
        name = "MAG_IB",
        real_name = "Ice Block",
        CD = 300,
        class = "MAGE",
        category = "DEFENSIVE",
        duration = 10,
    },
    {   -- Ice Barrier
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 11426,
        succ = "SPELL_CAST_SUCCESS",
        name = "MAG_IBAR",
        real_name = "Ice Barrier",
        CD = 25,
        class = "MAGE",
        category = "DEFENSIVE",
        duration = 0,
        talent = 16025,
    },
    {   -- Greater Invisibility
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 110959,
        succ = "SPELL_CAST_SUCCESS",
        name = "MAG_GI",
        real_name = "Greater Invisibility",
        CD = 90,
        class = "MAGE",
        category = "DEFENSIVE",
        duration = 20,
        talent = 16027,
    },
    -- Hunter
    {   -- Binding Shot
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 109248,
        succ = "SPELL_CAST_SUCCESS",
        name = "HUN_BS",
        real_name = "Binding Shot",
        CD = 45,
        class = "HUNTER",
        category = "AOE_STUN",
        duration = 10,
        talent = 19347,
    },    
    {   -- Aspect of the Fox
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 172106,
        succ = "SPELL_CAST_SUCCESS",
        name = "HUN_AOTF",
        real_name = "Aspect of the Fox",
        CD = 180,
        class = "HUNTER",
        category = "UTILITY",
        duration = 6,
    },    
    {   -- Deterrence
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 19263,
        succ = "SPELL_CAST_SUCCESS",
        name = "HUN_DET",
        real_name = "Deterrence",
        CD = 180,
        class = "HUNTER",
        category = "DEFENSIVE",
        duration = 5,
        talentReduceCD = { 118675, 60 },
        charges = 3,
    },
    {   -- Exhilaration
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = "inherit",
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 109304,
        succ = "SPELL_CAST_SUCCESS",
        name = "HUN_EX",
        real_name = "Exhilaration",
        CD = 120,
        class = "HUNTER",
        category = "DEFENSIVE",
        duration = 0,
        talent = 19350,
    },
   
    -- Everybody
    {   -- Healthstone
        enabled =  true,
        d_enabled = "inherit",
        b_enabled = false,
        startCDannounce = "inherit",
        stopCDannounce = "inherit",
        readyCDannounce = "inherit",
        readymode = "inherit",
        growth = "inherit",
        spellID = 6262,
        succ = "SPELL_CAST_SUCCESS",
        name = "ALL_HS",
        real_name = "Healthstone",
        CD = 3600,
        class = "ALL",
        category = "UTILITY",
        duration = 0,
    },  
}